package framework.taglib;

import java.io.IOException;
import java.util.ArrayList;

import javax.servlet.ServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.TagSupport;

import framework.service.ServiceMessage;

public class ErrorJsArrayTag extends TagSupport {

    public static final Boolean DEFAULT_JSHEADER = Boolean.TRUE;
	
    protected Boolean jsheader;
    protected String name;

    public ErrorJsArrayTag(){
    }

	public void release() {
		super.release();
	}

    public String getName()
    {
        return name;
    }

    public void setName(String name)
    {
        this.name = name;
    }

	public Boolean getJsheader() {
        return jsheader != null ? jsheader : DEFAULT_JSHEADER;
	}

	public void setJsheader(Boolean jsheader) {
		this.jsheader = jsheader;
	}

	public int doStartTag() throws JspException {

		ServletRequest request = super.pageContext.getRequest();

    	StringBuffer results = new StringBuffer();

		// G[bZ[W̎擾
		ArrayList msgList = getMessageList(request);

    	// JavaScriptwb_̏o
		addHeader(results, getJsheader());

		if ((msgList == null)||(msgList.size()==0)){
    		// G[Ȃ
    		results.append("var " + getName() + " = [];");

		} else {

    		// G[鎞
        	String fieldName = null;
            String errorMsg  = null;

    		results.append("var " + getName() + " = [");
    		for (int i = 0; i < msgList.size(); i++){
        		ServiceMessage error = (ServiceMessage)msgList.get(i);
        		fieldName = error.getKey();
        		errorMsg  = error.getMsg();
    			String delimiter = (i == 0) ? "" : ",";
    			results.append(delimiter + "{ \"key\":\""+ fieldName + "\", \"msg\" : \""+ errorMsg + "\"}");
            }
    		results.append("];");
    	}

    	// JavaScripttb^̏o
		addFooter(results, getJsheader());

		// ʂ֏o
		write(super.pageContext, results.toString());

        return 1;
    }

	protected ArrayList getMessageList(ServletRequest request){
		return (ArrayList)request.getAttribute(ErrorsTag.REQUEST_ATTRIBUTE_NAME);
	}

	private void addHeader(StringBuffer results, Boolean needHeader){
		if (Boolean.TRUE.equals(needHeader)){
			results.append("<script type=\"text/javascript\">");
		}
	}

	private void addFooter(StringBuffer results, Boolean needHeader){
		if (Boolean.TRUE.equals(needHeader)){
			results.append("</script>");
		}
	}

	private void write(PageContext pageContext, String text)
		throws JspException {
		JspWriter writer = pageContext.getOut();
		try{
			writer.print(text);
		}
		catch(IOException e){
		}
	}
}
