package framework.taglib;

import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.servlet.ServletRequest;
import javax.servlet.jsp.JspException;
import javax.servlet.jsp.JspWriter;
import javax.servlet.jsp.PageContext;
import javax.servlet.jsp.tagext.TagSupport;
import javax.servlet.http.HttpServletRequest;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.commons.beanutils.BeanUtilsBean;
import org.apache.taglibs.standard.lang.jpath.expression.BooleanLiteral;

import com.sun.org.apache.bcel.internal.generic.Type;

import framework.service.ServiceMessage;
import framework.service.ServiceParameter;
import framework.servlet.BaseAction;
import framework.form.BaseForm;

public class OptionsTag extends TagSupport {

	public static final String SCOPE_REQUEST = "request";
	public static final String SCOPE_SESSION = "session";
	public static final String DEFAULT_SCOPE = SCOPE_REQUEST;
    protected String name;
    protected String scope;
    protected String colection;
    protected String property;
    protected String labelProperty;

    public OptionsTag(){
    }

	public void release() {
		super.release();
	}

    public String getName()
    {
        return name;
    }

    public void setName(String name)
    {
        this.name = name;
    }
    
    public String getScope() {
		return scope != null ? scope : DEFAULT_SCOPE;
	}

	public void setScope(String scope) {
		this.scope = scope;
	}

	public String getColection() {
		return colection;
	}

	public void setColection(String colection) {
		this.colection = colection;
	}

	public String getLabelProperty() {
		return labelProperty;
	}

	public void setLabelProperty(String labelProperty) {
		this.labelProperty = labelProperty;
	}

	public String getProperty() {
		return property;
	}

	public void setProperty(String property) {
		this.property = property;
	}

	public int doStartTag() throws JspException {

		HttpServletRequest request = (HttpServletRequest)super.pageContext.getRequest();

		String name          = getName();
		String scope         = getScope();
		String colection     = getColection();
		String property      = getProperty();
		String labelProperty = (getLabelProperty()!=null) ? getLabelProperty() : property;

		// tH[Bean̎擾
		BaseForm beanData = (BaseForm)request.getAttribute(BaseAction.VIEW_ATTRIBUTE_NAME);
		if (beanData==null) return 1;

		// ^[Qbg̒l擾
		String formVal = (name!=null) ? getTargetValue(beanData, name) : "";

		// Xg̎擾
		List list = getTargetList(request, beanData, colection, scope);
		if (list==null) return 1;

		StringBuffer results = new StringBuffer();

		String val = null;
		String txt = null;
		for (int i = 0; i < list.size(); i++){
			Object rec = list.get(i);
			Map mapRec = null;
			if ((rec instanceof Map)||(rec instanceof HashMap)) {
				mapRec = (HashMap)rec;
			} else {
				try {
					mapRec = BeanUtils.describe(rec);
				} catch (Exception e) {
					e.printStackTrace();
					throw new JspException(e.toString());
				}
			}
			val = (String)mapRec.get(property);
			txt = (String)mapRec.get(labelProperty);
			results.append("<option value=\""+ val + "\"");
			if (val.equals(formVal)){
				results.append(" selected=\"selected\"");
			}
			results.append(">" + txt + "</option>\r\n");
		}

		write(super.pageContext, results.toString());

        return 1;
    }

	private String getTargetValue(BaseForm beanData, String name){
		String formVal = null;
		try {
			Map mapData = BeanUtils.describe(beanData);
			formVal = (String)mapData.get(name);
		} catch (Exception e) {
		}
		return formVal;
	}
	
	private List getTargetList(HttpServletRequest request, BaseForm beanData, String colection, String scope){

		List list = null;

		if (SCOPE_REQUEST.equals(scope)) {
			try {
				String methodName = "get" + (colection.charAt(0)+"").toUpperCase() + colection.substring(1);
				Method mthod = null;
				mthod = beanData.getClass().getMethod(methodName, new Class[]{});
				list = (List)mthod.invoke(beanData, new Object[]{});
			} catch (Exception e) {
			}
		} else if (SCOPE_SESSION.equals(scope)) {
			list = (List)request.getSession().getAttribute(colection);
		} else {

		}

		return list;
	}

	private void write(PageContext pageContext, String text)
		throws JspException {
		JspWriter writer = pageContext.getOut();
		try{
			writer.print(text);
		}
		catch(IOException e){
		}
	}
}
